use mapping_layer::MappingLayer;

mod mapping_layer;
mod parsing;
mod range_mapping;
pub fn solve_task_1(input: &str) -> String {
    let _parsed = parsing::parse(input);
    todo!()
}

fn location_of_one_point(seeds: u32, layers: &[MappingLayer]) -> u32 {
    todo!()
}

#[cfg(test)]
mod testing {
    use super::*;

    // Seed 79, soil 81, fertilizer 81, water 81, light 74, temperature 78, humidity 78, location 82.
    // Seed 14, soil 14, fertilizer 53, water 49, light 42, temperature 42, humidity 43, location 43.
    // Seed 55, soil 57, fertilizer 57, water 53, light 46, temperature 82, humidity 82, location 86.
    // Seed 13, soil 13, fertilizer 52, water 41, light 34, temperature 34, humidity 35, location 35.
    #[test]
    fn name() {
        fn assert_case(seeds: u32, layer: &[MappingLayer], expected: u32) {
            let actual = location_of_one_point(seeds, layer);
            assert_eq!(expected, actual, "Given seeds: {}", seeds);
        }
        let input = parsing::parse(include_str!("day5/day5_example_input.txt"));
        let layers = &input.1;
        assert_case(79, layers, 82);
        assert_case(14, layers, 43);
        assert_case(55, layers, 86);
        assert_case(13, layers, 35);
    }
}
